<template>
  <Menubar :model="items" class="p-py-1 p-px-2 p-mb-2">
    <template #start>
      <Button class="p-button-text p-p-1 p-button-link p-mr-2"
              @click="$router.push({name: 'home'})">
        <img alt="muavr" class="logo" src="@/assets/images/logo.png">
      </Button>
    </template>

    <template #end>
      <Button badge="9" badge-class="p-badge-success cart-amount" class="p-button-text p-button-plain"
              icon="far fa-shopping-cart"/>
      <Button class="p-button-text p-button-plain p-mx-1" icon="far fa-sign-in" :label="$t('navbar.login')"/>
      <Button :label="$t('navbar.locale')" class="p-button-text p-button-plain"
              icon="far fa-language" @click="changingLanguage = true"/>
    </template>
  </Menubar>
  <Sidebar v-model:visible="changingLanguage" class="p-sidebar-sm" position="right">
    <div v-t="'navbar.locale'" class="p-mb-5"/>
    <Listbox v-model="selectedLanguage" :options="availableLocales" option-label="name" option-value="code"
             @change="changeLocale">
      <template #option="slotProps">
        <div class="p-my-1">
          <img :alt="slotProps.option.name"
               :src="`https://raw.githubusercontent.com/lipis/flag-icon-css/master/flags/1x1/${slotProps.option.code}.svg`"
               class="country-image"/>
          <span class="p-ml-6">{{ slotProps.option.name }}</span>
        </div>
      </template>
    </Listbox>
  </Sidebar>
</template>

<script>
import { defineAsyncComponent } from 'vue';

export default {
  name: 'AppHeader',
  components: {
    Menubar: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/menubar" */ 'primevue/menubar')),
    Button: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/button" */ 'primevue/button')),
    Sidebar: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/sidebar" */ 'primevue/sidebar')),
    Listbox: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/listbox" */ 'primevue/listbox')),
  },
  data() {
    return {
      selectedLanguage: this.$i18n.locale,
      changingLanguage: false,
    };
  },
  computed: {
    items() {
      return [
        {
          icon: 'far fa-home-alt',
          label: this.$t('navbar.main'),
          to: '/',
        },
        {
          icon: 'far fa-store',
          label: this.$t('navbar.catalog'),
          to: '/catalog',
        },
        {
          icon: 'far fa-question-circle',
          label: this.$t('navbar.faq'),
          to: '/faq',
        },
        {
          icon: 'far fa-id-card',
          label: this.$t('navbar.contacts'),
          to: '/contacts',
        },
        {
          icon: 'far fa-balance-scale',
          label: this.$t('navbar.legal'),
          to: '/legal',
        },
      ];
    },
    availableLocales() {
      return this.getLocales()
          .map((el) => {
            this.loadLocale(el);

            return {
              name: this.$t('localeName', el),
              code: el,
            };
          });
    },
  },
  methods: {
    changeLocale(event) {
      if (event.value) {
        this.setLang(event.value);
      }
    },
  },
};
</script>

<style lang="scss">
.cart-amount {
  bottom:   0;
  position: absolute;
  right:    0;
}
</style>

<style lang="scss" scoped>
.logo {
  width: 100px;
}

.country-image {
  border-radius: 99px;
  position:      absolute;
  top:           7px;
  width:         30px;
}
</style>
